class
	OO_START

inherit
	TRANSFORMATION_STEP

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		do
			across transformer.tree.declarations as c loop
				if attached {AST_STRUCT_DECLARATION} c.item as sd then
					if sd.source_info.is_project_source then
						sd.identifier.prepend ("PD_")
					else
						sd.identifier.prepend ("SD_")
					end
				elseif attached {AST_ENUM_DECLARATION} c.item as ed then
					if ed.source_info.is_project_source then
						ed.identifier.prepend ("PC_")
					else
						ed.identifier.prepend ("SC_")
					end
				end
			end
			Result := True
		end

	description: STRING
		do
			Result := "Preparing O-O reengineering"
		end

end
