class
	UNUSED_SYSTEM_FEATURES_REMOVER

inherit
	TRANSFORMATION_STEP

feature {ANY} -- TRANSFORMATION_STEP

	process_impl: BOOLEAN
		local
			l_removed: BOOLEAN
		do
			across transformer.tree.declarations.twin as c loop
				if
					attached {AST_EIFFEL_FEATURE} c.item as ef and then
					ef.source_info.is_system_source and then
					ef.call_graph.in_calls.is_empty and then
					not (attached {AST_FUNCTION_DECLARATION} ef as fd and then fd.needs_address)
				then
					ef.call_graph.remove_out_calls
					delete_node (ef)
					l_removed := True
				end
			end
			if l_removed then
				process_impl.do_nothing
			end

			Result := True
		end

	description: STRING
		do
			Result := "Removing unused system features"
		end

end
